/*
 * Demonstration zur Anwendung des MagiCMac-Kernel-APIs
 */

#include <stddef.h>
#include "MgMc_API.h"

/* global vars */
static MgMcCookie *gMgMcCookie;

static MgMcCookie *getMgMcCookie ()
/* Diese Routine sucht den MgMc-Cookie; liefert NULL, wenn nicht vorhanden */
{
	long *p = *(long**)0x5A0;
	while (*p != 0) {
		if (*p == 'MgMc') {
			/* gefunden! */
			return p[1];
		}
		p += 2;
	}
	return NULL;
}

void main (void)
{
	char byte;
	long result;
	
	/* zuerst den MgMc-Cookie ermitteln */
	gMgMcCookie = getMgMcCookie ();
	if (!gMgMcCookie) exit (1);	/* Fehler - Cookie nicht da! */
	
	/* Schalter fr "Mac-Hintergrundprozesse" invertieren */
	if (!gMgMcCookie->configKernel) exit (2); /* Fehler - Funktion nicht vorhanden */
	byte = -1;
	result = gMgMcCookie->configKernel (2, &byte);
	if (result == -1) exit (3); /* Fehler - Sub-Funktion nicht vorhanden */
	byte = 1 - result;
	gMgMcCookie->configKernel (2, &byte);
	
	exit (0);
}
